#include <pro_ext.h>

#define argC_0 _HandToPtr(parm->p[0].val.ev_handle)
#define argC_1 _HandToPtr(parm->p[1].val.ev_handle)

#define argL_0  parm->p[0].val.ev_length
#define argL_1  parm->p[1].val.ev_length


#define dword  unsigned long
#define word   unsigned short
#define byte   unsigned char

typedef struct
 {
 dword seed1;
 dword seed2;
 dword max_value;
 dword max_value_dbl;
 }     RAND_S;

#define CCh _BreakPoint()

char rnd_0_31(RAND_S* rand_st, dword distance);

#define rnd_dist   31000000
#define rnd_base    1000000


//-----------inline ASM-----------------------------------------
 void        pushlong(dword digit);
           //-------
 #pragma aux pushlong =   \
 0x52    /* "push dx" */  \
 0x50    /* "push ax" */  \
 parm caller [dx ax];


 dword       fpu_oops(dword digit, dword distance);
           //-------
 #pragma aux fpu_oops =   \
 0x52      /* "push dx"           */  \
 0x50      /* "push ax"           */  \
 0x51      /* "push cx"           */  \
 0x53      /* "push bx"           */  \
 0x67 0xdb 0x44 0x24 0x08  /* "fild d,[esp+8]"    */  \
 0x67 0xdb 0x44 0x24 0x04  /* "fild d,[esp+4]"    */  \
 0xde 0xf9                 /* "fdivp st(1),st(0)" */  \
 0x67 0xdb 0x04 0x24       /* "fild d,[esp]"      */  \
 0xde 0xc9                 /* "fmulp st(1),st(0)" */  \
 0x67 0xdb 0x1c 0x24       /* "fistp d,[esp]"     */  \
 0x58      /* "pop  ax"           */  \
 0x5a      /* "pop  dx"           */  \
 0x59      /* "pop  cx"           */  \
 0x5b      /* "pop  bx"           */  \
 0x5b      /* "pop  bx"           */  \
 parm caller [dx ax] [cx bx] value [dx ax];
//-----------inline ASM-----------------------------------------


 char outstr[10]="ABCDEFGH_";

/*---------------------------------------------------------*/
/*---------------------------------------------------------*/
/*---------------------------------------------------------*/
void FAR MySqlHash(ParamBlk FAR* parm)
{
 char *mess,    *pass;
 byte  messlen,  passlen;
 char  hash[255];
 byte  i;

 outstr[0] = 0; // string top-1
      mess = argC_0;   // server hash+chr(0) <-
      pass = argC_1;   // passwd data+chr(0) ->
   messlen = (byte) argL_0;
   passlen = (byte) argL_1;

   if (messlen && mess[messlen-1]==0 && passlen && pass[0]!=0 && pass[passlen-1]==0)
      {                              // check "...+chr(0)"
      scramble(hash,mess,pass);      //_HLock(argH_0/1); not changed...
      for(i=0;i<=8; outstr[i]=hash[i], i++);
      }
 outstr[9] = 0; // string end-10
_RetChar(outstr);
};


/*---------------------------------------------------------*/
void scramble(char *to, char *message, char *password)
{
 RAND_S rand_st;
 dword  hash_mess[2],
        hash_pass[2];
 char   xorbyte;
 char  *to_again = to;

 hash_string(hash_mess,message );
 hash_string(hash_pass,password);

 randominit(&rand_st,hash_mess[0] ^ hash_pass[0],
                     hash_mess[1] ^ hash_pass[1]);
 while (*message++)
        *to++ = 64 + rnd_0_31(&rand_st,rnd_dist); // 'ABCD..._'

   /*---- Make it harder to break ----*/
     xorbyte = rnd_0_31(&rand_st,rnd_dist);
     while (to_again != to)
          *(to_again++) ^= xorbyte;
   /*-------1 with 0, 2 with 1...-----*/

 *to = 0; // string end: *AFTER* 2nd XOR-pass !
}
/*---------------------------------------------------------*/
void hash_string(dword *result, char *string)
{ // MUST BE!   "register"
  register dword nr0 = 1345345333L,
                 nr2 = 0x12345671L;
  dword add = 7;
  dword tmp;

    for(;*string;string++)
    {
    if (*string == ' ' || *string == '\t')
         continue;      /* skip spaces/tabs */
    tmp  = (dword) (byte) *string;
    nr0 ^= (((nr0 & 63) + add) * tmp) + (nr0 << 8);
    nr2 += (  nr2 << 8) ^ nr0;
    add += tmp;
    }
               /* Don't use sign bit (str2int) */
  result[0] = nr0 ^ 0x80000000L;
  result[1] = nr2 ^ 0x80000000L;
}

/*---------------------------------------------------------*/
char rnd_0_31(RAND_S* rand_st, dword distance)
{
  rand_st->seed1 = (rand_st->seed1*3+rand_st->seed2   ) % rand_st->max_value;
  rand_st->seed2 = (rand_st->seed1  +rand_st->seed2+33) % rand_st->max_value;

          // CCh;
             pushlong(rand_st->seed1);
  distance = fpu_oops(rand_st->max_value_dbl,distance)/rnd_base;
return ((char) distance);
}         // ... = 31 * (seed1/3FFFFFFFh)

/*---------------------------------------------------------*/
void randominit(RAND_S *rand_st,dword seed1, dword seed2)
{
  rand_st->max_value     = 0x3FFFFFFFL;
  rand_st->max_value_dbl = rand_st->max_value;
  rand_st->seed1 = seed1 % rand_st->max_value;
  rand_st->seed2 = seed2 % rand_st->max_value;
}


/*---------------------------------------------------------*/
/*---------------------------------------------------------*/
/*---------------------------------------------------------*/
FoxInfo myFoxInfo[] =
    {
    {"MYSQLHASH", MySqlHash, 2, "C,C"}
    };

FoxTable _FoxTable =
    {(FoxTable FAR *) 0, sizeof(myFoxInfo) / sizeof(FoxInfo), myFoxInfo};
